/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidMacroException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;


/**
* This item class contains methods to validate,set and get the attributes in {@link FrameAnatomySequence}.
 */

public class FrameAnatomySequenceItem extends Item
{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	GeneralAnatomyRequiredMacro objGeneralAnatomyRequiredMacro = null;

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 */
	FrameAnatomySequenceItem()
	{
		super();
		objGeneralAnatomyRequiredMacro = new GeneralAnatomyRequiredMacro(this);
	}

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	FrameAnatomySequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
		objGeneralAnatomyRequiredMacro = new GeneralAnatomyRequiredMacro(this);
	}

	/**
	 * This constructor creates FrameAnatomySequenceItem with specified TransferSyntax and
	 * specified DictionaryReader.
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax.
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used.
	 */
	FrameAnatomySequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
		objGeneralAnatomyRequiredMacro = new GeneralAnatomyRequiredMacro(this);
	}
	
	/**
	 * Sets Frame Laterality.
	 * @param strFrameLaterality String value of Frame Laterality.
	 */
	public void setFrameLaterality(String strFrameLaterality)
	{
		/* Accept the Frame Laterality in String format of type CS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0020,0x9072, strFrameLaterality,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0020,0x9072,DicomConstants.DCM_DT_CS, strFrameLaterality);

		addDataElement(objIDataElement);
	}

	/**
	 * Return user-defined label identifier for Fixation Device.
	 * @return String - value of Frame Laterality.
	 */
	public String getFrameLaterality()
	{
		Object objValue = getValue(0x0020,0x9072);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Retrieves the Instance of GeneralAnatomyRequiredMacro
	 * @return Instance of {@link GeneralAnatomyRequiredMacro}
	 */
	public GeneralAnatomyRequiredMacro getGeneralAnatomyRequiredMacro()
	{
		return objGeneralAnatomyRequiredMacro;
	}
	
	/**
	 * Validates all the attributes in FrameAnatomySequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule() throws InvalidItemException
	{
		try
		{
			/*
			 * Validation Rules for Mandatory Elements
			 */
			if(!contains(0x0020,0x9072))
				throw new MandatoryMissingException("0020,9072");
			
			/*
			 * Validation Rules for Macro
			 */
			objGeneralAnatomyRequiredMacro.validate();
		}
		catch( InvalidMacroException ime)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ime.getMessage());
			}
			throw new InvalidItemException(this.getClass().getSimpleName(),ime);
		}
		catch( MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new InvalidItemException(this.getClass().getSimpleName(),me);
		}
		return true;
	}
}
